///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using ColorManagement.ColorModels;
using ColorManagement.Conversions;
using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;

namespace Fluogen.DeployedScripts.ColorExtractors
{
	/// <summary>
	/// HCJ colors are very slow.
	/// </summary>
	public class HcjLightnessHue : ColorExtractor<DummyScriptConfiguration>
	{
		public override string Description => "RGB( HCJ( rc.support, 1, rc.main ) )";

		public override ExtractedColor Extract( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, ColorDeterminant a )
		{
			var hcj = new Hcj( a.Support, 1, a.Main );

			var color = PixelRgbColor.FromRgbScalar( HcjConverter.ToRgb( hcj, DependzConstants.ColorSpace, true ) );

			return new ExtractedColor( color );
		}
	}
}
