///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.ColorReducers;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.ColorReducers
{
	public class FractionalPartRepeater : RepeatedColorReducer<DummyScriptConfiguration>
	{
		public override string Description => "(rs * s1 + s2).FractionalPart( mirror )";

		protected override double ApplyUnitaryRepeater( IFluonContext fx, IFluonConfiguration fc, IColorReducerConfiguration crp, double x )
		{
			return (x * crp.S1 + crp.S2).FractionalPart( fc.MirrorWhenReducedColorFrequencyAndOffset );
		}
	}
}
