///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.ColorReducers;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.ColorReducers
{
	public class PhiAlways : AsymptoticColorReducer<DummyScriptConfiguration>
	{
		public override string Description => "rs.PhiAlways( s1 ); PhiAlways = rs >= 0 ? (s1 ^ 2 / (rs + |s1|)) : (s1 ^ 2 / (rs - |s1|))";

		public override void Validate( IFluonConfiguration fc, IColorReducerConfiguration crp )
		{
			base.Validate( fc, crp );

			if( crp.S1.IsZeroWithinEps() )
				throw new ArgumentException( $"{crp.Name}: crp.S1 == 0" );
		}

		protected override double ReduceAsymptoticallyToUnitary( IFluonContext fx, IFluonConfiguration fc, IColorReducerConfiguration crp
			, double x )
		{
			return x.PhiAlways( crp.S1 );
		}
	}
}
