///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.DomainProjectors
{
	public class LoopLnAbs : DomainProjector<DummyScriptConfiguration>
	{
		public override string Description => "(x - m1).LnA( s1 )";

		public override void Validate( IFluonConfiguration fc )
		{
			base.Validate( fc );

			if( fc.DomainProjectorS1 <= 0 || !fc.DomainProjectorS1.IsInteger() )
				throw new ArgumentException( $"{nameof( LoopLnAbs )}: DomainProjectorS1 <= 0 || !IsInteger( DomainProjectorS1 )" );
		}

		public override Mdn Project( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x )
		{
			int count = (int)fc.DomainProjectorS1;

			return (x - fc.DomainProjectorM1).LnA( count );
		}
	}
}
