///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.DomainProjectors
{
	public class PhiAlways : DomainProjector<DummyScriptConfiguration>
	{
		public override string Description => "(x ^ s2).PhiAlways( s1 ) + m1; PhiAlways = rs >= 0 ? (s1 ^ 2 / (rs + |s1|)) : (s1 ^ 2 / (rs - |s1|))";

		public override void Validate( IFluonConfiguration fc )
		{
			base.Validate( fc );

			if( fc.DomainProjectorS1.IsZeroWithinEps() )
				throw new ArgumentException( $"{nameof( PhiAlways )}: DomainProjectorS1 == 0" );
		}

		public override Mdn Project( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x )
		{
			return x.PowDnD1A( fc.DomainProjectorS2 ).PhiAlways( fc.DomainProjectorS1 ) + fc.DomainProjectorM1;
		}
	}
}
