
///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Fluogen.Dependz.Contexts;
using Fluogen.Dependz.FluonGenerators;
using Got.Libraries;

namespace Fluogen.DeployedScripts.FluonGenerators
{
	public class Julia3DXYPlaneRotationRadiusOriginal : IteratedFluonGeneratorWithSingleDomain<DummyScriptConfiguration, DummyCarryState>
	{
		protected override Mdn ProcessCodomainIteration( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y
			, ref DummyCarryState carryState )
		{
			Mdn m1 = fc.FluonGeneratorM1;

			// We have to rotate the domain only with its own first angle, the one from the XY plane. This means that we need a multiplier
			// with only the X and Y cartesians of the domain (while Z is 0).
			Mdn r = y.FromValuesOnAxes( 0, 1 );

			// The codomain's radius will be equal with the domain's radius.
			r.RadiusA = 1;

			return y.OptimizedMul( r ) + m1;
		}
	}
}
