///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.DeployedScripts.MdnPerturbators
{
	public class AddSinAngle0WithFrequency : MdnPerturbator<DummyScriptConfiguration>
	{
		public override string Description => "a + (y.u[ 0 ] * s1).Sin * s2";

		public override ColorDeterminant Accumulate( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y, Mdn yp
			, double ev, double evp, ColorDeterminant a, int ri )
		{
			return a.Add( (y.PolarForm.u[ 0 ] * fc.MdnPerturbatorS1).Sin() * fc.MdnPerturbatorS2 );
		}
	}
}
