///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Fluogen.Dependz.MdnReducers;
using Got.Libraries;

namespace Fluogen.DeployedScripts.MdnReducers
{
	public class RadiusYYpAccumulator : MdnReducerWithAccumulator<DummyScriptConfiguration>
	{
		public override string Description => "Accumulate: a + (y - yp).r + s1";

		public override ColorDeterminant Accumulate( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y, Mdn yp
			, double ev, double evp, ColorDeterminant a, int ri )
		{
			return a.Add( (y - yp).RadiusA + fc.MdnReducerS1 );
		}
	}
}
