///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Fluogen.Dependz.MdnReducers;
using Got.Libraries;

namespace Fluogen.DeployedScripts.MdnReducers
{
	public class SmoothieEtEvEvpAccumulator : MdnReducerWithAccumulator<DummyScriptConfiguration>
	{
		public override string Description => "Accumulate: a + (et - ev - evp).Exp";

		public override ColorDeterminant Accumulate( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y, Mdn yp
			, double ev, double evp, ColorDeterminant a, int ri )
		{
			double et = fc.EscapeThreshold;

			return a.Add( (et - ev - evp).Exp() );
		}
	}
}
