///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Fluogen.Dependz.MdnReducers;
using Got.Libraries;

namespace Fluogen.DeployedScripts.MdnReducers
{
	public class SmoothieEvEvEvpAccumulator : MdnReducerWithAccumulator<DummyScriptConfiguration>
	{
		public override string Description => "Accumulate: a + (l == 0 ? 0 : (-ev - 0.5 / l).Exp); l = |ev - evp|";

		public override ColorDeterminant Accumulate( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y, Mdn yp
			, double ev, double evp, ColorDeterminant a, int ri )
		{
			double l = (ev - evp).Abs();

			return a.Add( l.IsZeroWithinEps() ? 0 : (-ev - 0.5 / l).Exp() );
		}
	}
}
