///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.ScalarReducers
{
	public class Sin : ScalarReducer<DummyScriptConfiguration>
	{
		public override string Description => "(a * s1 + s2).Sin";

		public override ColorDeterminant Reduce( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, ColorDeterminant a )
		{
			return a.Replace( (a.Main * fc.ScalarReducerS1 + fc.ScalarReducerS2).Sin() );
		}
	}
}
